%global glib2_version 2.64
%global gtk3_version 3.22
%global gtksourceview_version 4.0.2
%global libpeas_version 1.14.1
%global gspell_version 1.0
%global pygo_version 3.0.0
%global apiver 41

%global __provides_exclude_from ^%{_libdir}/gedit/plugins/

%define __ninja_common_opts -v

Summary:      Text editor for the GNOME desktop
Name:         gedit
Version:      42.2
Release:      7%{?dist}
License:      GPLv2+ and GFDL
URL:          https://wiki.gnome.org/Apps/Gedit
Source0:      https://download.gnome.org/sources/%{name}/42/%{name}-%{version}.tar.xz

BuildRequires: meson
BuildRequires: pkgconfig(glib-2.0) >= %{glib2_version} pkgconfig(gobject-introspection-1.0)
BuildRequires: pkgconfig(gsettings-desktop-schemas) pkgconfig(gspell-1) >= %{gspell_version}
BuildRequires: pkgconfig(gtk+-3.0) >= %{gtk3_version} pkgconfig(libpeas-gtk-1.0) >= %{libpeas_version}
BuildRequires: pkgconfig(gtksourceview-4) >= %{gtksourceview_version} pkgconfig(iso-codes)
BuildRequires: pkgconfig(libsoup-2.4) pkgconfig(libxml-2.0) pkgconfig(pygobject-3.0)
BuildRequires: desktop-file-utils gettext which yelp-tools itstool vala
BuildRequires: python3-devel python3-gobject >= %{pygo_version}
BuildRequires: /usr/bin/appstream-util
Requires: glib2 >= %{glib2_version} gspell >= %{gspell_version}
Requires: gtk3 >= %{gtk3_version} gtksourceview4 >= %{gtksourceview_version}
Requires: libpeas-loader-python3 python3-gobject >= %{pygo_version}
Requires: zenity gsettings-desktop-schemas gvfs-client


%description
This package provides a small, but powerful text editor designed specifically for the GNOME 
desktop. It has not only has most of the standard text editor functions, but also includes 
advanced features such as highlighting, auto-indentation, and editing multiple documents in 
a single window. 
gedit can be extended through the plugin system to support spell checking, comparing files, 
viewing CVS ChangeLogs, and adjusting indentation levels. If you need more plugins, install 
the gedit-plugins package.

%package devel
Summary: Support for developing plugins for the gedit text editor
Requires: %{name} = %{version}-%{release}

%description devel
This package allows you to develop plugins that add new functionality to gedit.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%meson -Dgtk_doc=false
%meson_build

%install
%meson_install
%py_byte_compile %{__python3} %{buildroot}%{python3_sitelib}/gi/overrides
%py_byte_compile %{__python3} %{buildroot}%{_libdir}/gedit/plugins/

%find_lang %{name} --with-gnome

%check
appstream-util validate-relax --nonet %{buildroot}/%{_metainfodir}/org.gnome.gedit.appdata.xml
desktop-file-validate %{buildroot}%{_datadir}/applications/org.gnome.gedit.desktop

%files -f %{name}.lang
%license COPYING
%doc README.md NEWS
%{_bindir}/gedit
%{python3_sitelib}/gi/overrides/Gedit.py*
%{python3_sitelib}/gi/overrides/__pycache__
%{_libdir}/gedit/girepository-1.0/
%dir %{_libdir}/gedit
%dir %{_libdir}/gedit/plugins
%{_libdir}/gedit/libgedit-%{apiver}.so
%{_libdir}/gedit/plugins/docinfo.plugin
%{_libdir}/gedit/plugins/libdocinfo.so
%{_libdir}/gedit/plugins/filebrowser.plugin
%{_libdir}/gedit/plugins/libfilebrowser.so
%{_libdir}/gedit/plugins/openlinks.plugin
%{_libdir}/gedit/plugins/libopenlinks.so
%{_libdir}/gedit/plugins/modelines.plugin
%{_libdir}/gedit/plugins/libmodelines.so
%{_libdir}/gedit/plugins/externaltools.plugin
%{_libdir}/gedit/plugins/externaltools
%{_libdir}/gedit/plugins/pythonconsole.plugin
%{_libdir}/gedit/plugins/pythonconsole
%{_libdir}/gedit/plugins/quickopen.plugin
%{_libdir}/gedit/plugins/quickopen
%{_libdir}/gedit/plugins/snippets.plugin
%{_libdir}/gedit/plugins/snippets
%{_libdir}/gedit/plugins/quickhighlight.plugin
%{_libdir}/gedit/plugins/libquickhighlight.so
%{_libdir}/gedit/plugins/sort.plugin
%{_libdir}/gedit/plugins/libsort.so
%{_libdir}/gedit/plugins/spell.plugin
%{_libdir}/gedit/plugins/libspell.so
%{_libdir}/gedit/plugins/time.plugin
%{_libdir}/gedit/plugins/libtime.so
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.enums.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.externaltools.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.pythonconsole.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.filebrowser.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.filebrowser.enums.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.spell.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.time.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.gedit.plugins.time.enums.xml
%{_datadir}/dbus-1/services/org.gnome.gedit.service
%{_datadir}/icons/hicolor/*/apps/org.gnome.gedit.svg
%{_datadir}/icons/hicolor/symbolic/apps/org.gnome.gedit-symbolic.svg
%{_datadir}/gedit/
%{_datadir}/applications/org.gnome.gedit.desktop
%{_metainfodir}/org.gnome.gedit.appdata.xml
%{_mandir}/man1/gedit.1*

%files devel
%{_includedir}/gedit-%{apiver}/
%{_libdir}/pkgconfig/gedit.pc
%{_datadir}/vala/

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 42.2-7
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 42.2-6
- Rebuilt for loongarch release

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 42.2-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 42.2-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 42.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 42.2-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Mar 20 2023 Wang Guodong <gordonwwang@tencent.com> - 42.2-1
- package init.
